/*******************************************************************
 * Bluetooth Test Program
 * $B4J0W(BI/O$B%\!<%I$r;HMQ(B
 * $B%3%^%s%I$G2<5-<B9T(B
 * $B!!=PNO$N%*%s%*%U!">uBV$NF~NO!"7WB,%G!<%?$NF~NO(B
 *******************************************************************/
#include <xc.h>
/***** $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B *********/
// CONFIG1
#pragma config FOSC = INTOSC    // $BFbB"H/?6!!%/%m%C%/%T%s(BI/O
#pragma config WDTE = OFF       // WDT$B6X;_(B
#pragma config PWRTE = ON       // PWRT$BM-8z(B
#pragma config MCLRE = ON       // MCLR$BM-8z(B
#pragma config CP = OFF         // $B%W%m%F%/%H$J$7(B
#pragma config CPD = OFF        // $B%G!<%?%W%m%F%/%H$J$7(B
#pragma config BOREN = ON       // BOR$BM-8z(B
#pragma config CLKOUTEN = ON    // $B%/%m%C%/=PNO$"$j(B
#pragma config IESO = OFF       // $B%/%m%C%/@Z$jBX$($J$7(B
#pragma config FCMEN = OFF      // $B%/%m%C%/%b%K%?L58z(B
// CONFIG2
#pragma config WRT = OFF        // $B%;%k%U%i%$%HL58z(B
#pragma config PLLEN = ON       // PLL$BM-8z(B
#pragma config STVREN = OFF     // $B%9%?%C%/4F;k$J$7(B
#pragma config BORV = LO        // BOR$BDcEE05(B
#pragma config LVP = OFF        // LVP$B$J$7(B
/* $B%0%m!<%P%kJQ?t!"Dj?tDj5A(B */
#define     Fosc     32
unsigned char RcvFlag;
unsigned char RcvBuf[32], SndBuf[32], Buffer[32];
int Index;
#define Max_Size 32

/* Bluetooth$B@_DjMQ%3%^%s%I%G!<%?(B */
unsigned char msg1[] = "$$$";               // $B%3%^%s%I%b!<%I;XDj(B
unsigned char msg2[] = "SF,1\r";            // $B9)>l=P2Y%j%;%C%H(B
unsigned char msg3[] = "SN,BT_PIO\r";       // $BL>>N@_Dj(B
unsigned char msg4[] = "SA,4\r";            // $BG'>Z%b!<%I(B
unsigned char msg5[] = "R,1\r";             // $B:F5/F0(B
/* $B4X?t%W%m%H%?%$%T%s%0(B */
unsigned char getcUSART (void);
void Send(unsigned char txchar);
void SendStr(unsigned char * str);
void SendCmd(const unsigned char *cmd);
void RcvDisp(void);
void Process(void);
void delay_us(unsigned int usec);
void delay_ms(unsigned int msec);
void TRStart(void);
int  GetADC(int ch);

/*********** $B%a%$%s4X?t(B **************************/
int main(void){
     /** $B%/%m%C%/@_Dj(B **/
    OSCCON = 0xF0;                      // $BFbB"(B8MHz$B!!(BPLL On 32MHz
    /* $BF~=PNO%]!<%H$N@_Dj(B */
    ANSELA = 0x03;                      // RA0,1$B$N$_%"%J%m%0F~NO(B
    ANSELB = 0;
    TRISA = 0x23;
    TRISB = 0xDA;                       //
    WPUB = 0x18;                        // RB3,4 pullup
    OPTION_REGbits.nWPUEN = 0;          // Pullup Enable
    /************** Wi-Fi$B$H0[$J$kItJ,(B ******************************/
    /* BT$B%b%8%e!<%k=i4|2=(B */
    LATBbits.LATB0 = 0;                 // BT$B%b%8%e!<%k%j%;%C%H(B
    delay_ms(100);                      // $B%j%;%C%H;~4V(B
    LATBbits.LATB0 = 1;                 // $B%j%;%C%H2r=|(B
    delay_ms(500);                      // $B=i4|2=40N;BT$A(B    
    /* USART$B$N=i4|@_Dj(B */
    TXSTA = 0x24;                       // TXSTA,$BAw?.%b!<%I@_Dj(B BRGH=1
    RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
    BAUDCON=0x08;                       // BAUDCON$B!!(B16bit
    SPBRG = 68;                         // SPBRG,$BDL?.B.EY@_Dj(B(115kbps)
    /*Bluetooth$B%b%8%e!<%k$N@_Dj(B */
    if(PORTBbits.RB3 == 0){             // SW$B$,2!$5$l$F$$$k>l9g(B
        SendCmd(msg1);                  // $$$$B%3%^%s%I%b!<%I$X(B
        SendCmd(msg2);                  // $B9)>l=P2Y;~$X%j%;%C%H(B
        SendCmd(msg3);                  // $BL>>N@_Dj(B
        SendCmd(msg4);                  // $BG'>Z%b!<%I%l%,%7!<;XDj(B
        SendCmd(msg5);                  // $B%j%V!<%H(B
    }
    /* USART $B:F@_Dj(B*/
    TXSTA = 0x24;                       // TXSTA,$BAw?.%b!<%I@_Dj(B BRGH=0
    RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
    /*****************************************************************/
    /* ADC$B$N=i4|@_Dj(B */
    ADCON0 = 0;                         // ADC$BL58z2=(B
    ADCON1 = 0xE0;                      // $B1&5M$a!"(BVdd-Vss$B!!(BFosc/64    
    /* $BJQ?t=i4|2=(B */
    Index = 0;
    RcvFlag = 0;
    /* UART$B<u?.3d$j9~$_5v2D(B */
    PIR1bits.RCIF = 0;                  // $B3d$j9~$_%U%i%0%/%j%"(B
    PIE1bits.RCIE = 1;                  // USART$B<u?.3d$j9~$_5v2D(B
    INTCONbits.PEIE = 1;                // $B<~JU5v2D(B
    INTCONbits.GIE = 1;                 // $B%0%m!<%P%k5v2D(B

    /*************** $B%a%$%s%k!<%W(B ********************/
    while(1){
        if(RcvFlag){                    // $B<u?.$"$j$N>l9g(B
            RcvFlag = 0;                // $B<u?.%U%i%0%/%j%"(B
            /* $B<u?.%3%^%s%I=hM}(B */
            if((Buffer[0] == 'S')){     // $B%X%C%@3NG'(B
                SndBuf[0] = 'M';        // $B%X%C%@%;%C%H(B
                SndBuf[1] = Buffer[1];  // $B%X%C%@%;%C%H(B
                Process();              // $B%3%^%s%I=hM}<B9T(B
                Index = 0;              // $B%P%C%U%!%]%$%s%?%j%;%C%H(B
             }
        }
    }
}
/****************************************
 *$B!!<u?.%G!<%?=hM}4X?t(B
 ****************************************/
void Process(void){
    int data;

    /* $B%G!<%?=hM}(B  */
    switch(Buffer[1]){                                      // $B<u?.%G!<%?$GJ,4t(B
        /* $B>uBVF~NO$N>l9g(B */
        case 'B':
            SndBuf[2] = (PORTAbits.RA2 == 0) ? '0' : '1';   // Out1$B>uBV(B
            SndBuf[3] = (PORTAbits.RA3 == 0) ? '0' : '1';   // Out2$B>uBV(B
            SndBuf[4] = (PORTBbits.RB3 == 0) ? '0' : '1';   // SW1$B>uBV(B
            SndBuf[5] = (PORTBbits.RB4 == 0) ? '0' : '1';   // SW2$B>uBV(B
            /* $B7WB,CM<hF@(B **/
            data = GetADC(0);                               // CH0$B$N(BA/D$BJQ49(B
            SndBuf[6] = (unsigned char)(data / 32)+0x40;    // $B>e0L(B5$B%S%C%HJ,(B
            SndBuf[7] = (unsigned char)(data % 32)+0x40;    // $B2<0L(B5$B%S%C%HJ,(B
            data = GetADC(1);                               // CH1$B$N(BA/D$BJQ49(B
            SndBuf[8] = (unsigned char)(data / 32)+0x40;    // $B>e0L(B5$B%S%C%HJ,(B
            SndBuf[9] = (unsigned char)(data % 32)+0x40;    // $B2<0L(B5$B%S%C%HJ,(B
            SndBuf[10] = 'E';                               // $B=*N;%^!<%/(B
            SendStr(SndBuf);                                // $BAw?.<B9T(B
            break;
        /* $B=PNO@)8f$N>l9g(B */
        case 'C':
            switch(Buffer[2]){                              // $B6hJL5-9f$GJ,4t(B
                case '1':                                   // $B=PNO#1<B9T(B
                    LATAbits.LATA2 = (Buffer[3] == '1') ? 1 : 0;
                    break;
                case '2':                                   // $B=PNO(B2$B<B9T(B
                    LATAbits.LATA3 = (Buffer[3] == '1') ? 1 : 0;
                    break;
                default: break;
            }
            break;
        default: break;
    }
}
/***************************************
*  USART$B<u?.3d$j9~$_=hM}4X?t(B
****************************************/
void interrupt isr(void){
    unsigned char data;
    int i;

    if(PIR1bits.RCIF){                              // $B<u?.3d$j9~$_$+!)(B
        PIR1bits.RCIF = 0;                          // $B<u?.3d$j9~$_%U%i%0%/%j%"(B
        if((RCSTAbits.OERR) || (RCSTAbits.FERR)){   // $B%(%i!<H/@8$7$?>l9g(B
            data = RCREG;                           // $B%@%_!<FI$_=P$7(B
            RCSTA = 0;                              // USART$BL58z2=(B
            RCSTA = 0x90;                           // USART$B:FM-8z2=(B
        }
        else {                                      // $B@5>o<u?.$N>l9g(B
            if(Index < Max_Size){                         // $B%P%C%U%!%*!<%P!<%U%m!<$G$J$$>l9g(B
                data = RCREG;                       // $B%G!<%?<h$j=P$7(B
                if(data == 'S')                     // $B3+;O%^!<%/$N>l9g(B
                    Index = 0;                      // $B%P%C%U%!%$%s%G%C%/%9%j%;%C%H(B
                RcvBuf[Index] = data;               // $B%G!<%?3JG<(B
                /* $B=*N;%^!<%/$N=hM}(B */
                if(RcvBuf[Index] == 'E'){           // $B=*N;%^!<%/(BE$B8!=P(B
                    i = 0;                          // $B%]%$%s%?%j%;%C%H(B
                    while(i <= Index){              // $B<u?.%P%$%H?t7+$jJV$7(B
                        Buffer[i] = RcvBuf[i];      // $B%3%T!<(B
                        i++;                        // $B%P%C%U%!%]%$%s%?99?7(B
                    }
                    RcvFlag = 1;                    // $B<u?.40N;%U%i%0%;%C%H(B
                }
                Index++;                            // $B%P%C%U%!%]%$%s%?99?7(B
            }
            else{                                   // $B%P%C%U%!%*!<%P!<$N>l9g(B
                data = RCREG;                       // $BFI$_Ht$P$7$FL5;k(B
                Index = 0;                          // $B%$%s%G%C%/%9%j%;%C%H(B
            }
        }
    }
}
/********************************
 * USART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char txchar){
    while(!TXSTAbits.TRMT);             // $BAw?.%l%G%#!<BT$A(B
    TXREG = txchar;                     // $BAw?.<B9T(B
}
/********************************
 * Bluetooth$BJ8;zNsAw?.4X?t(B
 *******************************/
void SendStr(unsigned char * str){
    int i;
    
    for(i= 0; i<Max_Size; i++)                // 32$B%P%$%HAw?.(B
        Send(*str++);                   // $BAw?.<B9T(B
}
/********************************
 * Bluetooth$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 ********************************/
void SendCmd(const unsigned char *cmd){
    while(*cmd != 0)                    // $B=*C<$^$G7+$jJV$7Aw?.(B
        Send(*cmd++);                   // $BAw?.<B9T(B
    delay_ms(1000);                     // $BJV?.%9%-%C%WMQCY1d(B
}
/**************************************************
*  $B%"%J%m%0%G!<%?F~NO4X?t(B
*  AD$B%3%s%P!<%?$NF~NO@)8f(B
***************************************************/
int GetADC(int ch){
    int value;

    /* $B29EY7WB,(B */
    ADCON0 = (ch << 2) + 0x01;		// $B%A%c%M%kA*Br!"(BADC$BM-8z2=(B
    delay_us(20);                       // $B%"%/%$%8%7%g%sBT$A(B
    ADCON0bits.GO = 1;                  // AD$BJQ493+;O(B
    while (ADCON0bits.GO);		// AD$BJQ4940N;BT$A(B
    value = ADRESL+(ADRESH*256);	// 10bit$B$NCM$KJQ49(B
    return(value);                      // $BJQ497k2L<hF@(B
}
/**********************************
*  $B%k!<%WCY1d4X?t!!(Busec$BC10L(B
**********************************/
void delay_us(unsigned int usec){
    unsigned int Max, k;

    Max = usec * Fosc/30;
    for(k=0; k<Max; k++)
    {   }
}
/**********************************
*  $B%k!<%WCY1d4X?t!!(Bmsec$BC10L(B
**********************************/
void delay_ms(unsigned int msec){
    int j;

    for(j=0; j<msec; j++)
     delay_us(1000);
}
