/*******************************************************************
 * WiFi Module Twitter$B<B9T%W%m%0%i%`(B
 * Twitter Board$B$r;HMQ(B
 * Twitter$B$G$D$V$d$/(B
 * $B!!30It=PNO$N%*%s%*%U!"30It>uBV$NF~NO!"7WB,%G!<%?$NF~NO(B
 * $B!!JV?.$G@)8f$r<B9T$9$k(B
 *******************************************************************/
#include <xc.h>
#include "lcd_lib3.h"

/***** $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B *********/
// CONFIG1
#pragma config FOSC = INTOSC    // Oscillator Selection (INTOSC oscillator: I/O function on CLKIN pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = ON       // Brown-out Reset Enable (Brown-out Reset enabled)
#pragma config CLKOUTEN = OFF   // Clock Out Enable (CLKOUT function is disabled. I/O or oscillator function on the CLKOUT pin)
#pragma config IESO = OFF       // Internal/External Switchover (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)

// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config VCAPEN = OFF     // Voltage Regulator Capacitor Enable (All VCAP pin functionality is disabled)
#pragma config PLLEN = ON       // PLL Enable (4x PLL enabled)
#pragma config STVREN = OFF     // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will not cause a Reset)
#pragma config BORV = LO        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), low trip point selected.)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)

/* $B%0%m!<%P%kJQ?t!"Dj?tDj5A(B */
unsigned char MState, SW, Select, CFlag, State, GetFlag, ContFlag;
unsigned char RcvBuf[512], data;
unsigned char PostFlag, TimeFlag, NotSame;
float Ondo, Ondo1;
int Index, i, Sec, Value, count, STCode;
unsigned long Pascal;
persistent unsigned int  Min, Hour;
unsigned long Number, OldNumber;

/* WiFi$B@_DjMQ%3%^%s%I%G!<%?(B */
const unsigned char SSID[] = "000A79E7FA41";                        // $B<+Bp%"%/%;%9%]%$%s%H(B
const unsigned char PASS[] = "73733829";
//const unsigned char SSID[] = "GL01P-10C61FEC94D7";                // $B%]%1%C%H(BWiFi
//const unsigned char PASS[] = "10585117";
const unsigned char msg1[] = "$$$";                                 // $B%3%^%s%I%b!<%I;XDj(B
const unsigned char msg2[] = "factory R\r";                         // $B=i4|2=(B
const unsigned char msg3[] = "set wlan ssid ";                      // AP$B$N(BSSID$B;XDj(B
const unsigned char msg4[] = "set wlan pass ";                      // AP$BMQ%M%C%H%o!<%/%-!<;XDj(B
const unsigned char msg41[] = "set wlan join 1\r";                  // AP$B$X$N<+F0@\B3(B
const unsigned char msg5[] = "set ip proto 18\r";                   // HTTP,TCP$B;XDj(B
const unsigned char msg6[] = "set ip host 0\r";                     // $B%/%i%$%"%s%HB&%"%I%l%9;XDj(B
const unsigned char msg7[] = "set ip remote 80\r";                  // $B%/%i%$%"%s%HB&%]!<%H;XDj(B
const unsigned char msg8[] = "set dns name stewgate-u.appspot.com\r"; // StewGaten$B$N%"%I%l%9;XDj(B
const unsigned char msg9[] = "set b i 0\r";                         // $B%V%m!<%I%-%c%9%HDd;_(B
const unsigned char msg10[] = "set comm remote 0\r";                // Hello$B%a%C%;!<%86X;_(B
const unsigned char msg11[] = "set comm open 0\r";                  // Open$B%a%C%;!<%86X;_(B
const unsigned char msg12[] = "save\r";                             // $B@_DjJ]B8(B
const unsigned char msg13[] = "reboot\r";                           // $B:F5/F0(B
const unsigned char msg14[] = "open\r";                             // $B@\B3@)8f(B
const unsigned char msg15[] = "close\r";                            // TCP$B%/%m!<%:%3%^%s%I(B
const unsigned char msg16[] = "set comm time 150\r";                // $B;~4V$GAw?.3+;O(B
const unsigned char msg17[] = "set comm size 1400\r";               // $B%P%C%U%!3NJ](B
const unsigned char msg18[] = "set comm match 0\r";                 // $B0lCW$GAw?.3+;O$J$7(B
const unsigned char msg19[] = "set comm close 0\r";                 // Close$B%a%C%;!<%86X;_(B
const unsigned char msg20[] = "sleep\r";                            // $B%9%j!<%W@)8f(B
const unsigned char msg21[] = "\r";                                 // CR

/* LCD Message */
const unsigned char StMsg[]   = "Start Twitter!! ";
unsigned char Time[]    = "Time xx:xx:xx   ";
unsigned char Data[]    = "T=xx H=xx P=xxxx";
unsigned char SetHour[] = "Set Hour xx     ";
unsigned char SetMin[]  = "Set Min  xx     ";
unsigned char SetSec[]  = "Set Sec  xx     ";
const unsigned char MsgSame[] = "Same Number Skip";
const unsigned char ErrMsg[]  = "Rcv Error Code!!";
const unsigned char Spc[] = "                ";

/* Post$BMQ%a%C%;!<%8(B */
const unsigned char Account[] = "GokanTT";
const unsigned char Token[] = "830f98f131d98704c73d4a9d3a324207";
const unsigned char post1[] = "POST /api/post/ HTTP/1.0\r\n";
const unsigned char post2[] = "Host: stewgate-u.appspot.com\r\n";
unsigned char post3[] = "Content-Length: xxx";
const unsigned char post4[] = "\r\n\r\n_t=";                 // $B$3$N8e(BToken$B$rB3$1$k(B
const unsigned char post5[] = "&msg=";                          // $B$3$N8e%a%C%;!<%8$rB3$1$k(B

/*$B!!(B10$B;~(B23$BJ,(B  $B?e(B xx.x$B!n(B  $BIt20(B xx.x$B!n(B  $B>HL@(B Off  $B%R!<%?(B Off$B!!(B*/
unsigned char room[] = {
    0x31, 0x30, 0xE6, 0x99, 0x82, 0x32, 0x33, 0xE5, 0x88, 0x86, 0x20, 0x20, 0xE6, 0xB0, 0xB4, 0x20,
    0x78, 0x78, 0x2E, 0x78, 0xE2, 0x84, 0x83, 0x20, 0x20, 0xE9, 0x83, 0xA8, 0xE5, 0xB1, 0x8B, 0x20,
    0x78, 0x78, 0x2E, 0x78, 0xE2, 0x84, 0x83, 0x20, 0x20, 0x20, 0xE7, 0x85, 0xA7, 0xE6, 0x98, 0x8E,
    0x20, 0x4F, 0x66, 0x66, 0x20, 0x20, 0xE3, 0x83, 0x92, 0xE3, 0x83, 0xBC, 0xE3, 0x82, 0xBF, 0x20,
    0x4F, 0x66, 0x66, 0x0D, 0x0A, 0x00};
/* $B$A$g$C$H4($$$h(B! */
const unsigned char samui[] = {
    0x20, 0xE3, 0x81, 0xA1, 0xE3, 0x82, 0x87, 0xE3, 0x81, 0xA3, 0xE3, 0x81, 0xA8, 0xE5, 0xAF, 0x92,
    0xE3, 0x81, 0x84, 0xE3, 0x81, 0xAD, 0xEF, 0xBC, 0x81, 0x20, 0x00};
/* $B$A$g$&$I$$$$$h(B! */
const unsigned char choudo[] = {
    0x20, 0xE3, 0x81, 0xA1, 0xE3, 0x82, 0x87, 0xE3, 0x81, 0x86, 0xE3, 0x81, 0xA9, 0xE3, 0x81, 0x84,
    0xE3, 0x81, 0x84, 0xE3, 0x82, 0x88, 0xEF, 0xBC, 0x81, 0x20, 0x00};
/* $B$A$g$C$H=k$$$h(B! */
const unsigned char atui[]   = {
    0x20, 0xE3, 0x81, 0xA1, 0xE3, 0x82, 0x87, 0xE3, 0x81, 0xA3, 0xE3, 0x81, 0xA8, 0xE6, 0x9A, 0x91,
    0xE3, 0x81, 0x84, 0xE3, 0x82, 0x88, 0xEF, 0xBC, 0x81, 0x20, 0x00};
/* $B@)8f$r<B9T$7$?$h(B! */
const unsigned char seigyo[] ={
    0x20, 0xE5, 0x88, 0xB6, 0xE5, 0xBE, 0xA1, 0xE3, 0x82, 0x92, 0xE5, 0xAE, 0x9F, 0xE8, 0xA1, 0x8C,
    0xE3, 0x81, 0x97, 0xE3, 0x81, 0x9F, 0xE3, 0x82, 0x88, 0x21};

/* GET$BMQ%a%C%;!<%8(B */
const unsigned char post11[] = "POST /api/last_mention/ HTTP/1.0\r\n";
const unsigned char post12[] = "Host: stewgate-u.appspot.com\r\n";
const unsigned char post13[] = "Content-Length: 35\r\n\r\n_t=";                  //32+3
const unsigned char post14[] = "\r\n";


/* $B4X?t%W%m%H%?%$%T%s%0(B */
unsigned char Receive(void);
void Send(unsigned char Data);
void SendStr(const unsigned char * str);
void SendCmd(const unsigned char *cmd);
void RcvProcess(void);
void Execute();
void delay_us(unsigned short usec);
void delay_ms(unsigned short msec);
void ftostring(int seisu, int shousu, float data, unsigned char *buffer);
void itostring(unsigned char digit, unsigned int data, unsigned char *buffer);
unsigned char ChkKey(void);
void CurDisp(void);
void Settings(void);

/*********** $B%a%$%s4X?t(B **************************/
int main(void)
{
     /* $B%/%m%C%/<~GH?t$N@_Dj(B */
    OSCCON = 0x70;                          // 8MHz PLL On = 32MHz
    /* WiFi$B3+;O%j%;%C%H%a%C%;!<%8%9%-%C%W(B */
    delay_ms(1000);                         // $BL5>r7o%9%-%C%W(B
    /* I/O$B=i4|2=(B */
    LATA = 0xFC;                            // 
    ANSELA = 0x03;                          // RA0,1(AN0,1)
    ANSELB = 0x30;                          // RB4,5(AN11,13)
    TRISA = 0x03;                           // $B%]!<%H(BA
    TRISB = 0xFF;                           // $B%]!<%H(BB
    TRISC = 0x19;                           // $B%]!<%H(BC
    WPUB = 0x0F;                            // Pullup RB0-3
    OPTION_REGbits.nWPUEN = 0;              // Pull Up Enable
    /** I2C$B=i4|2=(B **/
    SSPADD = 0x4F;                          // 100kHz@8MHz
    SSPCON1 = 0x38;                         // I2C$B%$%M!<%V%k(B
    SSPSTAT = 0;                            // $B>uBV%/%j%"(B    
    // $B1U>=I=<(4o$N=i4|2=$H3+;O%a%C%;!<%8I=<((B
    LATCbits.LATC2 = 1;                     // $B%j%;%C%H2r=|(B
    delay_ms(100);
    lcd_init();
    lcd_cmd(0x01);                          // $BA4>C5n(B
    lcd_str(StMsg);    
    /*Wi-Fi$B%j%;%C%H!!(B*/
    LATCbits.LATC5 = 0;
    delay_ms(100);
    LATCbits.LATC5 = 1;
    delay_ms(500);
    /* USART$B$N=i4|@_Dj(B 9.6kbps*/
    TXSTA = 0x20;                           // TXSTA,$BAw?.%b!<%I@_Dj(B
    RCSTA = 0x90;                           // RCSTA,$B<u?.%b!<%I@_Dj(B
    BAUDCON=0x08;                           // BAUDCON$B!!(B16bit
    SPBRG = 207;                            // SPBRG,$BDL?.B.EY@_Dj(B(9.6kbps)
    /* ADC$B$N=i4|@_Dj(B */
    ADCON0 = 0;                             // ADC$BL58z2=(B
    ADCON1 = 0xE0;                          // $B1&5M$a!"(BVdd-Vss$B!!(BFosc/64
    /* $BJQ?t=i4|2=(B */
    Index = 0;                              // $B%P%C%U%!%$%s%G%C%/%9=i4|2=(B
    MState = 0;
    PostFlag = 0;
    TimeFlag = 1;
    OldNumber = 0;
    Number = 0;
    CFlag = 0;
    if(PORTBbits.RB0 == 0)                 // SW5$B$,2!$5$l$F$$$k>l9g(B
    {
        /** Wi-Fi$B%b%8%e!<%k=i4|2=!!%$%s%U%i%b!<%I(B */
        delay_ms(1000);
        SendCmd(msg1);                      //$$$
        SendCmd(msg2);
        SendStr(msg3);                      // SSID$B@_Dj(B
        SendStr(SSID);
        SendCmd(msg21);
        SendStr(msg4);                      // PIN$B%3!<%I@_Dj(B
        SendStr(PASS);
        SendCmd(msg21);
        SendCmd(msg41);                     // $B<+F0@\B3;XDj(B
        SendCmd(msg5);                      // $B%W%m%H%3%k;XDj(B
        SendCmd(msg6);                      // $B%/%i%$%"%s%HB&%]!<%H@_Dj(B
        SendCmd(msg7);                      // $B%j%b!<%HB&%]!<%H@_Dj(B
        SendCmd(msg8);                      // DNS$B@_Dj(B
        SendCmd(msg9);                      // UDP$B%V%m!<%I%-%c%9%HDd;_(B
        SendCmd(msg16);                     // $B;~4V$GAw?.3+;O(B
        SendCmd(msg17);                     // $B%P%C%U%!3NJ](B
        SendCmd(msg18);                     // $B0lCW$GAw?.$J$7(B
        SendCmd(msg19);                     // close$B1~Ez$J$7(B
        SendCmd(msg10);                     // $B3+;O%a%C%;!<%8$J$7(B
        SendCmd(msg11);                     // Stop Open Message
        SendCmd(msg12);                     // save
        SendCmd(msg13);                     // reboot
        delay_ms(1000);                     // $B1~Ez%9%-%C%W(B
        /** USART $B:F@_Dj(B*/
        TXSTA = 0x20;                       // TXSTA,$BAw?.%b!<%I@_Dj(B
        RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
    }
    SendCmd(msg1);                          // $$$
    SendCmd(msg20);                         // sleep
    /* $B%?%$%^#1=i4|@_Dj(B */
    T1CON = 0x8D;                           // $B30It%/%m%C%/!!HsF14|(B
    TMR1H = 0x80;                           // 1$BIC<~4|$K%;%C%H(B
    PIR1bits.TMR1IF = 0;                    // $B3d$j9~$_%U%i%0%/%j%"(B
    PIE1bits.TMR1IE = 1;                    // $B%?%$%^#13d$j9~$_5v2D(B
    INTCONbits.PEIE = 1;                    // $B<~JU3d$j9~$_0l3g5v2D(B
    INTCONbits.GIE = 1;                     // $B%0%m!<%P%k3d$j9~$_5v2D(B

    /*************** $B%a%$%s%k!<%W(B ********************/
    while(1){
        /* $B;~9o@_DjF0:n%A%'%C%/(B */
        SW = ChkKey();                          // $B%9%$%C%AF~NO%A%'%C%/(B
        if(SW != 0){                            // $B%9%$%C%AF~NO$"$j$N>l9g(B
            CFlag = 1;                          // $B@_DjCf%U%i%0%;%C%H(B
            T1CON = 0;                          // $B%?%$%^(B1$BDd;_(B
            Settings();                         // $B;~9o@_Dj=hM}(B
            T1CON = 0x8D;                       // $B%?%$%^:F3+(B
        }
        /** $B;~9oI=<((B **/
        if(TimeFlag){                           // $B;~9oI=<(MW5a$"$j$N>l9g(B
            TimeFlag = 0;                       // $B%U%i%0%/%j%"(B
            itostring(2, Hour, Time+5);         // $B;~4V$rJ8;z$KJQ49(B
            itostring(2, Min, Time+8);          // $BJ,$rJ8;z$KJQ49(B
            itostring(2, Sec, Time+11);         // $BIC$rJ8;z$KJQ49(B
            lcd_cmd(0x80);                      // LCD1$B9TL\;XDj(B
            lcd_str(Time);                      // $B;~9oI=<((B
        }
        /****** $B:G?7$N$D$V$d$-JVEz$r<hF@(B ********************/
        if(GetFlag == 1){                       // $B%A%'%C%/;~4V$N>l9g(B
            lcd_cmd(0xC0);                      // 2$B9TL\(B
            lcd_str(Spc);                       // LCD$B>C5n(B
            GetFlag = 0;                        // $B%A%'%C%/%U%i%0%/%j%"(B          
            /*WiFi$B%j%;%C%H!!(B*/
            LATCbits.LATC5 = 0;                 // $B%j%;%C%H?.9f=PNO(B
            delay_ms(100);
            LATCbits.LATC5 = 1;                 // $B%j%;%C%H2r=|(B
            delay_ms(1000);                     //$B!!=hM}BT$A(B
            /** USART $B:F@_Dj(B*/
            TXSTA = 0x20;                       // TXSTA,$BAw?.%b!<%I@_Dj(B
            RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
            /* $B%5!<%P$H@\B3(B */
            SendCmd(msg1);                      // $$$
            SendCmd(msg14);                     // Open
            delay_ms(2000);                     // $B1~Ez%a%C%;!<%8%9%-%C%W(B
            /* Tweet Send */
            SendStr(post11);                    // Get$B%3%^%s%IAw?.(B
            SendStr(post12);
            SendStr(post13);                    // _t=$BAw?.(B
            SendStr(Token);                     // $B%H!<%/%sAw?.(B
            SendStr(post14);                    // $B%a%C%;!<%8Aw?.(B
            /* $B<u?.%G!<%?=hM}(B */
            Index = 0;                          // $B<u?.%P%C%U%!%]%$%s%?%j%;%C%H(B
            State = 0;                          // $B<u?.%9%F!<%H%j%;%C%H(B
            STCode = 0;                         // $B%9%F!<%H%3!<%I%j%;%C%H(B
            /* $B<u?.7+$jJV$7(B */
            while(State < 7)                    // $B%9%F!<%H=*N;$^$G7+$jJV$7(B
                RcvProcess();                   // 1$BJ8;z<u?.=hM}(B
            Execute();                          // $B<u?.%G!<%?=hM}<B9T(B
            /** USART $B:F@_Dj(B*/
            TXSTA = 0x20;                       // TXSTA,$BAw?.%b!<%I@_Dj(B
            RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
            /*to Sleep Mode */
            delay_ms(5000);
            SendCmd(msg1);                      // $$$            
            SendCmd(msg20);                     // sleep
        }
        /*** Twitter$B$K$D$V$d$-Aw?.(B ***********************/
        if(PostFlag == 1){                      // $BAw?.%U%i%0%*%s$N>l9g(B
            PostFlag = 0;
            /* $B;~9oJQ49(B */
            itostring(2, Hour, room+0);
            itostring(2, Min, room+5);
            /* $B29EY7WB,(B */
            ADCON0 = 0x01;			// AN0 POT$BA*Br!"(BADC$BM-8z2=(B
            delay_us(20);                       // $B%"%/%$%8%7%g%sBT$A(B
            ADCON0bits.GO = 1;                  // AD$BJQ493+;O(B
            while (ADCON0bits.GO);		// AD$BJQ4940N;BT$A(B
            Value = ADRESL+(ADRESH*256);	// 10bit$B$NCM$KJQ49(B
            Ondo = ((float)(Value) * 50.0)/1024;// $B29EY$X%9%1!<%kJQ49(B
            ftostring(2, 1, Ondo, room+16);
            ADCON0 = 0x0B;                      // AN11
            delay_us(20);                       // $B%"%/%$%8%7%g%sBT$A(B
            ADCON0bits.GO = 1;                  // AD$BJQ493+;O(B
            while (ADCON0bits.GO);		// AD$BJQ4940N;BT$A(B
            Value = ADRESL+(ADRESH*256);	// 10bit$B$NCM$KJQ49(B
            Ondo1 = ((float)(Value) * 50.0)/1024;// $B29EY$X%9%1!<%kJQ49(B
            ftostring(2, 1, Ondo1, room+32);
            /* $B>uBV%;%C%H(B */
            if(PORTAbits.RA4 == 0){
                room[49] = 0x4F;                // On$B%;%C%H(B
                room[50] = 0x6E;
                room[51] = 0x20;
            }
            else{
                room[49] = 0x4F;                // Off$B%;%C%H(B
                room[50] = 0x66;
                room[51] = 0x66;
            }
            if(PORTAbits.RA5 == 0){
                room[64] = 0x4F;                // On$B%;%C%H(B
                room[65] = 0x6E;
                room[66] = 0x20;
            }
             else{
                room[64] = 0x4F;                // Off$B%;%C%H(B
                room[65] = 0x66;
                room[66] = 0x66;
            }               
            /*WiFi$B%j%;%C%H!!(B*/
            LATCbits.LATC5 = 0;
            delay_ms(100);
            LATCbits.LATC5 = 1;
            delay_ms(1000);
            /** USART $B:F@_Dj(B*/
            TXSTA = 0x20;                       // TXSTA,$BAw?.%b!<%I@_Dj(B
            RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
            /* $B%5!<%P$H@\B3(B */
            SendCmd(msg1);                      // $$$
            SendCmd(msg14);                     // Open
            delay_ms(1000);
            /* $BJ8;z?t%;%C%H(B */ 
            if(ContFlag == 1){                  // $B@)8f1~Ez$N>l9g(B
                data = sizeof(room)-1+sizeof(seigyo)-1+sizeof(Token)+8;
                itostring(3, data, post3+16);                
            }
            else{                               // $B@)8f1~Ez$G$J$$>l9g(B
                if(Ondo <= 23){
                    data = sizeof(room)-1+sizeof(samui)-1+sizeof(Token)+8;
                    itostring(3, data, post3+16);
                }
                else{
                    if(Ondo >= 30){
                        data = sizeof(room)-1+sizeof(atui)-1+sizeof(Token)+8;
                        itostring(3, data, post3+16);
                    }
                    else{
                        data = sizeof(room)-1+sizeof(choudo)-1+sizeof(Token)+8;
                        itostring(3, data, post3+16);
                    }
                }
            }
            /******* Tweet$BAw?.(B *********/
            SendStr(post1);                     // $B%a%C%;!<%8Aw?.(B
            SendStr(post2);
            SendStr(post3);
            SendStr(post4);
            SendStr(Token);
            SendStr(post5);                     // $B%a%C%;!<%8Aw?.(B
            SendStr(room);
            if(ContFlag == 1){                  // $B@)8f1~Ez$N>l9g(B
                SendStr(seigyo);
                ContFlag = 0;
            }
            else{                               // $B@)8f$G$J$$>l9g(B
                if(Ondo <= 23)                  // 23$B!n0J2<$N>l9g(B
                    SendStr(samui);
                else{
                    if(Ondo >= 30)              // 30$B!n0J>e$N>l9g(B
                        SendStr(atui);
                    else
                        SendStr(choudo);        // 23$B!n$+$i(B30$B!n$N4V$N>l9g(B
                }
            }
            SendStr(post14);                    // CRLF
            /*to Sleep Mode */
            delay_ms(1000);
            SendCmd(msg1);                      // $$$
            SendCmd(msg20);                     // sleep
        }
        SLEEP();
    }
}

/*****************************************************************
 *$B!!<u?.=hM}4X?t(B
 * $B!!%U%)!<%^%C%H(B
 * $B!!G/7nF|;~J,IC(B|$B%a%C%;!<%8(BID$B!CAw?.<TL>(B|$B!w(Bxxx $B%a%C%;!<%8(B
 ****************************************************************/
void RcvProcess(void)
{
    data = Receive();
    if(data != 0xFF){
        switch(State){
            case 0:                                     // Skip HTTP/1.0
                if(data == ' ')
                    State++;
                break;
            case 1:
                if((data >= '0') && (data <= '9')){     // Get Error Code
                    STCode *= 10;
                    STCode += data - '0';               // Code$B$r?tCM$KJQ49(B
                }
                else
                    State++;
                break;
            case 2:
                    if(STCode == 200)                   // $B@5>o%3!<%I$N>l9g(B
                        State++;                        // $B<!$N%9%F!<%H$X(B
                    else
                        State = 7;                      // $B%(%i!<%3!<%I$N>l9g6/@)=*N;(B
                    break;
            case 3:
                if(data == '|')                         // $B6-3&$N(B|$B$r%5!<%A(B
                    State++;
                break;
            case 4:
                if((data >= '0') && (data <= '9')){     // $B%a%C%;!<%8(BID$B$N<hF@(B
                    Number *= 10;
                    Number += data - '0';               // ID$B$r?tCM$KJQ49(B
                }
                else
                    State++;                            // $B<hF@40N;$G<!$X(B
                break;
            case 5:
                if(data == '@')                         // @$B%5!<%A(B
                    State++;                            // $BH/8+$G<!$X(B
                break;
            case 6:
                if((data != 0)&&(Index<512))            // $B%a%C%;!<%8:G8e$^$G7+$jJV$7(B
                    RcvBuf[Index++] = data;             // $B%a%C%;!<%8$r%P%C%U%!$KJ]B8(B
                else
                    State++;                            // $B:G8e$G(BState7$B$H$9$k(B
                break;
            default :
                break;
        }
    }
}
/****************************************
 * $B<u?.%G!<%?=hM}4X?t(B
 * $B@)8f$N<B9T(B
 ****************************************/
void Execute(void){
    if(STCode != 200){                                  // $B@5>o1~Ez$G$J$$>l9g(B
        lcd_cmd(0xC0);                                  // $B%(%i!<%a%C%;!<%8I=<((B
        lcd_str(ErrMsg);
    }
    else {                                              // $B@5>o1~Ez$N>l9g(B
        if(Number == OldNumber){                        // $B%a%C%;!<%8(BID$B$,F1$8>l9g(B
            lcd_cmd(0xC0);
            lcd_str(MsgSame);                           // $B%a%C%;!<%8I=<($N$_<B9T(B
        }
        else{                                           // $B0[$J$k%a%C%;!<%8(BID$B$N>l9g(B
            lcd_clear();                                // $B%a%C%;!<%8$rI=<((B
            lcd_cmd(0xC0);
            lcd_str(RcvBuf);
            OldNumber = Number;                         // $B%a%C%;!<%8(BID$B99?7(B
            /**** $B<u?.%G!<%?$K$h$k@)8f<B9T(B ****/
            /* $B%"%+%&%s%H$N0lCW3NG'(B **/
            NotSame = 0;
            count = sizeof(Account) - 1;                // $B%"%+%&%s%H$NJ8;z?t<hF@(B
            for(i=0; i< count-1; i++){                  // $B%"%+%&%s%H$NHf3S(B
                if(Account[i] != RcvBuf[i])             // $B0[$J$k>l9g(B
                    NotSame = 1;                        // $B0[$J$k%U%i%0%;%C%H(B
            }
            /** $B%"%+%&%s%H$,0lCW$7$?>l9g(B **/
            if(NotSame == 0){
                /* CT$B%-!<%o!<%I0lCW3NG'(B */
                if((RcvBuf[count+1] == 'C')&&(RcvBuf[count+2]=='T')){
                    /* $B%"%I%l%9$GJ,4t(B */
                    if(RcvBuf[count+3]=='L'){           // CTL$B$N>l9g(B
                        if(RcvBuf[count+4] == '1')
                            LATAbits.LATA2 = 0;         // On
                        else
                            LATAbits.LATA2 = 1;         // Off
                    }
                    else if(RcvBuf[count+3]=='H'){      // CTH$B$N>l9g(B
                        if(RcvBuf[count+4] == '1')
                            LATAbits.LATA3 = 0;         // On
                        else
                            LATAbits.LATA3 = 1;         // Off
                    }
                }
                ContFlag = 1;                           // $B@)8f<B9T%U%i%0%;%C%H(B
                PostFlag = 1;                           // $B1~Ez%D%$!<%H%U%i%0%;%C%H(B
            }
        }
    }
}
/******************************************
 * $B%?%$%^(B1$B3d$j9~$_=hM}4X?t(B
 * 30$BJ,<~4|$G(BTweet$B!!!!(B2$BJ,<~4|$GJV?.%A%'%C%/(B
 ******************************************/
void interrupt T1ISR(void){
    unsigned long MSB8, Lower;

    PIR1bits.TMR1IF = 0;                        // $B3d$j9~$_%U%i%0%/%j%"(B
    TMR1H = 0x80;
    TimeFlag = 1;
    Sec++;
    
    if(Sec >= 60){                              // 1$BJ,4V3V(B
        Sec = 0;
        /* $B;~9o%+%&%s%H%"%C%W(B */
        Min++;					// $BJ,99?7(B
        if(Min >= 60){				// 60$BJ,%A%'%C%/(B
            Min = 0;
            Hour++;				// $B;~4V99?7(B
            if(Hour >= 24){			// 24$B;~%A%'%C%/(B
                Hour = 0;
            }
        }
        /* $BJV?.$r<hF@$9$k;~4V%A%'%C%/(B **/
        if((Min % 2) == 1)                      // $B4q?tJ,$G(BGet$B<B9T(B
            GetFlag = 1;        
        /* $B$D$V$d$-;~4V%A%'%C%/(B **/
        if((Min % 30)== 0)                      // 30$BJ,$4$H$K%]%9%H<B9T(B
            PostFlag = 1;            
    }
 }

/******************************************
* $B;~9o@_Dj=hM}(B
*$B!!(BKey$B!'(BSelect$B!"(BUp$B!"(BDown$B!"(BSet
*******************************************/
void Settings(void){
    Select = 0;					// $B;~4V$K=i4|@_Dj(B
    CurDisp();                                  // $B;~4V@_DjI=<((B
    while(ChkKey() != 0);			// $B%A%c%C%?2sHr(B
    delay_ms(25);
    while(CFlag){				// $B99?7Cf%U%i%0%*%s(B
        SW = ChkKey();				// $B%9%$%C%AF~NO(B
        while(ChkKey() != 0);			// $B%A%c%C%?2sHr(B
        delay_ms(25);
        /* $B%9%$%C%A$4$H$N%W%m%;%9(B */
        switch(SW){
            case 1:		
                Select++;			// $BA*Br9`L\99?7(B
                if(Select > 2)			// $B>e8B%A%'%C%/(B
                Select = 0;			
                CurDisp();			// $B8=:_CMI=<((B
                break;
            case 2:
                switch(Select){			// $B%"%C%W=hM}(B
                    case 0:
                        Hour++;			// $B;~4V%"%C%W(B
                        if(Hour > 23)
                            Hour = 0;
                        break;
                    case 1:
                        Min++;			// $BJ,%"%C%W(B
                        if(Min > 59)
                            Min = 0;
                        break;
                    case 2:
                        Sec++;			// $BIC%"%C%W(B
                        if(Sec > 59)
                            Sec = 0;
                        break;
                    default: break;
                }
                CurDisp();			// $B99?7CMI=<((B
                break;
            case 3:
                switch(Select){			// $B%@%&%s=hM}(B
                    case 0:
                        if(Hour > 0)		// $B;~4V%@%&%s(B
                            Hour--;
                        else
                            Hour = 23;
                        break;
                    case 1:
                        if(Min > 0)		// $BJ,%@%&%s(B
                            Min--;
                        else
                            Min = 59;
                        break;
                    case 2:
                        if(Sec > 0)		// $BIC%@%&%s(B
                            Sec--;
                        else
                            Sec = 59;
                        break;
                    default: break;
                }
                CurDisp();			// $B99?7CMI=<((B
                break;
            case 4:				// $B@_Dj40N;=hM}(B
                CFlag = 0;                      // $B@_DjCf%U%i%0%j%;%C%H(B
                break;
            default: break;
        }
    }
}
/********************************************
*  $B8=:_CM;~9oI=<(%5%V4X?t!J@_DjCf$NI=<((B )
********************************************/
void CurDisp(void){
    lcd_cmd(0x80);
    switch(Select){
        case 0:
            itostring(2, Hour, SetHour+9);      // $B;~4VI=<((B
            lcd_str(SetHour);
            break;
        case 1:
            itostring(2, Min, SetMin+9);        // $BJ,I=<((B
            lcd_str(SetMin);
            break;
        case 2:
            itostring(2, Sec, SetSec+9);        // $BICI=<((B
            lcd_str(SetSec);
            break;
        default: break;         
    }
}
/****************************************
*  $B%9%$%C%AF~NO%5%V4X?t(B
*  $BLa$jCM$K%9%$%C%AHV9f(B
***************************************/
unsigned char ChkKey(void){
    unsigned char Key;

    Key = 0;                                // $B=i4|CM%/%j%"(B
    if(PORTBbits.RB0 == 0)                  // Select$B%9%$%C%A(B
        Key = 1;                            // 1$B$rJV$9(B
    else if(PORTBbits.RB1 == 0)             // Up$B%9%$%C%A(B
        Key = 2;                            // 2$B$rJV$9(B
    else if(PORTBbits.RB2 == 0)             // Down$B%9%$%C%A(B
        Key = 3;                            // 3$B$rJV$9(B
    else if(PORTBbits.RB3 == 0)             // Enter$B%9%$%C%A(B
        Key = 4;                            // 4$B$rJV$9(B
    return(Key);
}	

/***************************************
*  UART$B<u?.%5%V4X?t(B
****************************************/
unsigned char Receive(void)
{
    long counter;

    counter = 0;                                // $B%?%$%`%"%&%HMQ%+%&%s%?(B
    while(PIR1bits.RCIF == 0){                  // $B<u?.%l%G%#!<$+!)(B
        counter++;                              // $B%?%$%`%"%&%H%+%&%s%?99?7(B
        if(counter > 50000)                     // $B%?%$%`%"%&%H$N>l9g(B
            break;                              // $B6/@)=*N;(B
    }
    PIR1bits.RCIF = 0;                          // $B3d$j9~$_%U%i%0%/%j%"(B
    if(counter > 50000)                         // $B%?%$%`%"%&%H$N>l9g(B
        return(0);                              // 0$B$rJV$9(B
    else{
        /* $B<u?.%(%i!<%A%'%C%/(B */
        if(RCSTAbits.OERR || RCSTAbits.FERR) {  // $B<u?.%(%i!<$N>l9g(B
            data = RCREG;;                      // $B%@%_!<<h$j=P$7(B
            RCSTA = 0;
            TXSTA = 0;
            TXSTA = 0x20;                       // TXSTA,$BAw?.%b!<%I@_Dj(B
            RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
            return(0xFF);                       // FF$B$rJV$9(B
        }
        else {                                  // $B@5>o<u?.$N>l9g(B
            return(RCREG);                      // $B<u?.%G!<%?$rJV$9(B
        }
    }
}
 /********************************
 * UART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char Data){
    while(!TXSTAbits.TRMT);                     // $BAw?.%l%G%#!<BT$A(B
    TXREG = Data;                               // $BAw?.<B9T(B
}
/********************************
 * WiFi$BJ8;zNsAw?.4X?t(B
 *******************************/
void SendStr(const unsigned char * str)
{
    while(*str != 0)                            // $BJ8;zNs:G8e$^$G7+$jJV$7(B
        Send(*str++);                           // $BAw?.<B9T(B
}
/********************************
 * WiFi$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 ********************************/
void SendCmd(const unsigned char *cmd)
{
    while(*cmd != 0)                            // $B=*C<$^$G7+$jJV$7Aw?.(B
        Send(*cmd++);                           // $BAw?.<B9T(B
    delay_ms(1000);                             // $BJV?.%9%-%C%WMQCY1d(B
}
/***************************************
* int$B@0?t$+$i(BASCII$BJ8;z$KJQ49(B
****************************************/
void itostring(unsigned char digit, unsigned int data, unsigned char *buffer){
	unsigned char i;

	buffer += digit;			// $B:G8e$N?t;z0LCV(B
	for(i=digit; i>0; i--) {		// $BJQ49$O2<0L$+$i>e0L$X(B
		buffer--;			// $B%]%$%s%?!<#1(B
		*buffer = (data % 10) + '0';	// ASCII$B$X(B
		data = data / 10;		// $B<!$N7e$X(B
	}
}
/***********************************
* Float$B$+$iJ8;zNs$XJQ49(B
* $B9g7WM-8z7e$O(B8$B7e0J2<$H$9$k$3$H(B
***********************************/
void ftostring(int seisu, int shousu, float data, unsigned char *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)				//$B>.?tIt7e$"$j$+(B
        buffer += seisu+shousu+1;		//$BA4BN7e?t!\>.?tE@(B
    else					//$B>.?tIt7e$J$7$N$H$-(B
        buffer += seisu + shousu;		//$BA4BN7e?t$N$_(B
    buffer--;					//$BG[Ns%]%$%s%?(B-1
    for(i=0; i<shousu; i++)			//$B>.?tIt$r@0?t$KJQ49(B
        data = data * 10;			//$B#1#0G\(B
    /// dumy$B$,%*!<%P!<%U%m!<$9$k$HJQ49IT2D(B($B#87e$,8B3&(B)
    dumy = (long) (data + 0.5);			//$B;M<N8^F~$7$F@0?t$KJQ49(B
    for(i=shousu; i>0; i--)	{		//$B>.?t7e?tJ,7+$jJV$7(B
        *buffer =(dumy % 10)+'0';		//$B?tCM$rJ8;z$KJQ493JG<(B
        buffer--;				//$B3JG<>l=j2<0L$+$i>e0L$X(B
        dumy /= 10;				//$B<!$N7e$X(B
    }
    if(shousu != 0) {				//$B>.?t7e(B0$B$J$i>.?tE@$J$7(B
        *buffer = '.';				//$B>.?tE@$r3JG<(B
        buffer--;				//$B%]%$%s%?(B-1
    }
    for(i=seisu; i>0; i--) {			//$B@0?t7eJ,7+$jJV$7(B
        *buffer = (dumy % 10)+'0';		//$B?tCM$rJ8;z$KJQ493JG<(B
        buffer--;				//$B%]%$%s%?(B-1
        dumy /= 10;				//$B<!$N7e$X(B
    }
    i = 0;					// $B%V%i%s%-%s%0=hM}(B
    buffer++;
    while((i<seisu-1)&&(*buffer == '0')){       // $B>e0L7e$,(B0$B$N4V(B
        *buffer = ' ';				// $B%V%i%s%/$KJQ49(B
        buffer++;
        i++;
    }
}


