/*******************************************************************
 * WiFi Module TCP/UDP Test Program
 * $B4J0W(BI/O$B%\!<%I$r;HMQ(B
 * TCP$B$^$?$O(BUDP$B%3%^%s%I$G2<5-<B9T(B
 * $B!!=PNO$N%*%s%*%U!">uBV$NF~NO!"7WB,%G!<%?$NF~NO(B
 *******************************************************************/
#include <xc.h>
/***** $B%3%s%U%#%.%e%l!<%7%g%s$N@_Dj(B *********/
// CONFIG1
#pragma config FOSC = INTOSC    // $BFbB"H/?6!!%/%m%C%/%T%s(BI/O
#pragma config WDTE = OFF       // WDT$B6X;_(B
#pragma config PWRTE = ON       // PWRT$BM-8z(B
#pragma config MCLRE = ON       // MCLR$BM-8z(B
#pragma config CP = OFF         // $B%W%m%F%/%H$J$7(B
#pragma config CPD = OFF        // $B%G!<%?%W%m%F%/%H$J$7(B
#pragma config BOREN = ON       // BOR$BM-8z(B
#pragma config CLKOUTEN = ON    // $B%/%m%C%/=PNO$"$j(B
#pragma config IESO = OFF       // $B%/%m%C%/@Z$jBX$($J$7(B
#pragma config FCMEN = OFF      // $B%/%m%C%/%b%K%?L58z(B
// CONFIG2
#pragma config WRT = OFF        // $B%;%k%U%i%$%HL58z(B
#pragma config PLLEN = ON       // PLL$BM-8z(B
#pragma config STVREN = OFF     // $B%9%?%C%/4F;k$J$7(B
#pragma config BORV = LO        // BOR$BDcEE05(B
#pragma config LVP = OFF        // LVP$B$J$7(B
/* $B%0%m!<%P%kJQ?t!"Dj?tDj5A(B */
#define     Fosc     32
unsigned char RcvFlag;
unsigned char RcvBuf[32], SndBuf[32], Buffer[32];
int Index;
/* $B%$%s%U%i%b!<%IMQ$N(BWiFi $B@_DjMQ%3%^%s%I%G!<%?(B */
const unsigned char msg1[] = "$$$";                                 // $B%3%^%s%I%b!<%I;XDj(B
const unsigned char msg2[] = "factory R\r";                         // $B=i4|2=(B
const unsigned char msg3[] = "set wlan ssid 000A79E7FA41\r";        // AP$B$N(BSSID$B;XDj(B
const unsigned char msg4[] = "set wlan pass 73733829\r";            // AP$BMQ%M%C%H%o!<%/%-!<;XDj(B
//const unsigned char msg3[] = "set wlan ssid GL01P-10C61FEC94D7\r";  // $B%]%1%C%H(BWiFi$B$N(BSSID
//const unsigned char msg4[] = "set wlan pass 10585117\r";            // $B%]%1%C%H(BWiFi$B$N(BPIN$B%3!<%I(B
const unsigned char msg5[] = "set ip proto 3\r";                    // UDP/TCP$B;XDj(B
const unsigned char msg51[] = "set wlan join 1\r";                  // $B<+F0@\B3(B
const unsigned char msg6[] = "set ip host 192.168.1.29\r";          // $B%/%i%$%"%s%HB&%"%I%l%9;XDj(B
const unsigned char msg7[] = "set ip remote 3000\r";                // $B%/%i%$%"%s%HB&%]!<%H;XDj(B
const unsigned char msg8[] = "set ip local 2000\r";                 // $B<+J,$N%]!<%H;XDj(B
const unsigned char msg9[] = "set b i 0\r";                         // $B%V%m!<%I%-%c%9%HDd;_(B
const unsigned char msg10[] = "set comm remote 0\n";                // Hello$B%a%C%;!<%86X;_(B
const unsigned char msg11[] = "set comm open 0\r";                  // Open$B%a%C%;!<%86X;_(B
const unsigned char msg12[] = "save\r";                             // $B@_DjJ]B8(B
const unsigned char msg13[] = "reboot\r";                           // $B:F5/F0(B
const unsigned char msg14[] = "close\r";                            // TCP$B%/%m!<%:%3%^%s%I(B
/* $B%=%U%H(BAP$B%b!<%IMQ$N%3%^%s%I%G!<%?(B*/
const unsigned char msg21[] = "set wlan join 7\r";                  // $B%=%U%H(BAP$B%b!<%I;XDj(B
const unsigned char msg22[] = "set wlan ssid MyAP\r";               // SSID$B@_Dj(B
const unsigned char msg23[] = "set ip dhcp 4\r";                    // DHCP$B%5!<%PM-8z2=(B
const unsigned char msg24[] = "set ip address 1.2.3.5\r";           // IP$B%"%I%l%9(B
const unsigned char msg25[] = "set ip net 255.255.255.0\r";         // $B%5%V%M%C%H%^%9%/(B
const unsigned char msg26[] = "set ip gateway 1.2.3.5\r";           // $B%2!<%H%&%'%$(BIP$B%"%I%l%9(B

/* $B4X?t%W%m%H%?%$%T%s%0(B */
unsigned char getcUSART (void);
void Send(unsigned char txchar);
void SendStr(unsigned char * str);
void SendCmd(const unsigned char *cmd);
void RcvDisp(void);
void Process(void);
void delay_us(unsigned int usec);
void delay_ms(unsigned int msec);
void TRStart(void);
int  GetADC(int ch);
void itostring(unsigned char digit, unsigned int data, unsigned char *buffer);
void ftostring(int seisu, int shousu, float data, unsigned char *buffer);

/*********** $B%a%$%s4X?t(B **************************/
int main(void){
     /** $B%/%m%C%/@_Dj(B **/
    OSCCON = 0xF0;                      // $BFbB"(B8MHz$B!!(BPLL On 32MHz
    /* $BF~=PNO%]!<%H$N@_Dj(B */
    ANSELA = 0x03;                      // RA0,1$B$N$_%"%J%m%0F~NO(B
    ANSELB = 0;
    TRISA = 0x23;
    TRISB = 0xDA;                       //
    WPUB = 0x18;                        // RB3,4 pullup
    OPTION_REGbits.nWPUEN = 0;          // Pullup Enable
    /***************** Bluetooth$B$H0[$J$kItJ,(B *************************/
    /* WiFi$B%b%8%e!<%k=i4|2=(B */
    LATBbits.LATB0 = 0;                 // WiFi$B%b%8%e!<%k%j%;%C%H(B
    delay_ms(100);                      // $B%Q%k%9I}3NJ](B
    LATBbits.LATB0 = 1;                 // $B%j%;%C%H2r=|(B
    delay_ms(500);                      // $B=i4|2=40N;BT$A(B    
    /* USART$B$N=i4|@_Dj(B 9.6kbps*/
    TXSTA = 0x20;                       // TXSTA,$BAw?.%b!<%I@_Dj(B
    RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
    BAUDCON=0x08;                       // BAUDCON$B!!(B16bit
    SPBRG = 207;                        // SPBRG,$BDL?.B.EY@_Dj(B(9.6kbps)
    /* Wi-Fi$B%b%8%e!<%k$N@_Dj(B */
    if(PORTBbits.RB3 == 0){             // SW$B$,2!$5$l$F$$$k>l9g(B
        /***************************************************************/
        /* WiFi$B%b%8%e!<%k=i4|2=!!%$%s%U%i%b!<%I(B */
        delay_ms(500);                  // $BL5Aw?.;~4V3NJ](B
        SendCmd(msg1);                  // $$$$B$G%3%^%s%I%b!<%I$X(B
        SendCmd(msg2);                  // $B9)>l=P2Y;~%j%;%C%H(B
        SendCmd(msg3);                  // SSID$B%;%C%H(B
        SendCmd(msg4);                  // PIN$B%3!<%I%;%C%H(B
        SendCmd(msg5);                  // $B%W%m%H%3%k;XDj!J(BTCP+UDP)
        SendCmd(msg51);                 // $B<+F0@\B3M-8z2=(B
        SendCmd(msg6);                  // $B%j%b!<%H(BIP$B%"%I%l%9;XDj(B
        SendCmd(msg7);                  // $B%j%b!<%H%]!<%HHV9f;XDj(B
        SendCmd(msg8);                  // $B<+J,$N%]!<%HHV9f;XDj(B
        SendCmd(msg9);                  // $B%V%m!<%I%-%c%9%HDd;_(B
        SendCmd(msg10);                 // Hello$B%a%C%;!<%86X;_(B
        SendCmd(msg11);                 // Open$B%a%C%;!<%86X;_(B
        SendCmd(msg12);                 // save
        SendCmd(msg13);                 // reboot
        /* USART $B:F@_Dj(B*/
        TXSTA = 0x20;                   // TXSTA,$BAw?.%b!<%I@_Dj(B BRGH=0
        RCSTA = 0x90;                   // RCSTA,$B<u?.%b!<%I@_Dj(B
        /***************************************************************/
        /* WiFi$B%b%8%e!<%k=i4|2=!!%=%U%H(BAP$B%b!<%IMQ(B */
//        delay_ms(500);                      // $BL5Aw?.;~4V3NJ](B
//        SendCmd(msg1);                      // $$$$B$G%3%^%s%I%b!<%I$X(B
//        SendCmd(msg2);                      // $B9)>l=P2Y;~%j%;%C%H(B
//        SendCmd(msg21);                     // $B%=%U%H(BAP$B%b!<%I;XDj(B
//        SendCmd(msg22);                     // SSID$B;XDj(B
//        SendCmd(msg23);                     // DHCP$B%5!<%PM-8z2=(B
//        SendCmd(msg24);                     // IP$B%"%I%l%9;XDj(B
//        SendCmd(msg25);                     // $B%5%V%M%C%H%^%9%/;XDj(B
//        SendCmd(msg26);                     // $B%2!<%H%&%'%$(BIP$B%"%I%l%9;XDj(B
//        SendCmd(msg12);                     // save
//        SendCmd(msg13);                     // reboot
//        /* USART $B:F@_Dj(B*/
//        TXSTA = 0x20;                       // TXSTA,$BAw?.%b!<%I@_Dj(B BRGH=0
//        RCSTA = 0x90;                       // RCSTA,$B<u?.%b!<%I@_Dj(B
        /****************************************************************/
    }
    /*****************************************************************/
    /* ADC$B$N=i4|@_Dj(B */
    ADCON0 = 0;                         // ADC$BL58z2=(B
    ADCON1 = 0xE0;                      // $B1&5M$a!"(BVdd-Vss$B!!(BFosc/64    
    /* $BJQ?t=i4|2=(B */
    Index = 0;
    RcvFlag = 0;
    /* UART$B<u?.3d$j9~$_5v2D(B */
    PIR1bits.RCIF = 0;                  // $B3d$j9~$_%U%i%0%/%j%"(B
    PIE1bits.RCIE = 1;                  // USART$B<u?.3d$j9~$_5v2D(B
    INTCONbits.PEIE = 1;                // $B<~JU5v2D(B
    INTCONbits.GIE = 1;                 // $B%0%m!<%P%k5v2D(B

    /*************** $B%a%$%s%k!<%W(B ********************/
    while(1){
        if(RcvFlag){                    // $B<u?.$"$j$N>l9g(B
            RcvFlag = 0;                // $B<u?.%U%i%0%/%j%"(B
            /* $B<u?.%3%^%s%I=hM}(B */
            if((Buffer[0] == 'S')){     // $B%X%C%@3NG'(B
                SndBuf[0] = 'M';        // $B%X%C%@%;%C%H(B
                SndBuf[1] = Buffer[1];  // $B%X%C%@%;%C%H(B
                Process();              // $B%3%^%s%I=hM}<B9T(B
                Index = 0;              // $B%P%C%U%!%]%$%s%?%j%;%C%H(B
             }
        }
    }
}
/****************************************
 *$B!!<u?.%G!<%?=hM}4X?t(B
 ****************************************/
void Process(void){
    int data;

    /* $B%G!<%?=hM}(B  */
    switch(Buffer[1]){                                      // $B<u?.%G!<%?$GJ,4t(B
        /* $B>uBVF~NO$N>l9g(B */
        case 'B':
            SndBuf[2] = (PORTAbits.RA2 == 0) ? '0' : '1';   // Out1$B>uBV(B
            SndBuf[3] = (PORTAbits.RA3 == 0) ? '0' : '1';   // Out2$B>uBV(B
            SndBuf[4] = (PORTBbits.RB3 == 0) ? '0' : '1';   // SW1$B>uBV(B
            SndBuf[5] = (PORTBbits.RB4 == 0) ? '0' : '1';   // SW2$B>uBV(B
            /* $B7WB,CM<hF@(B **/
            data = GetADC(0);                               // CH0$B$N(BA/D$BJQ49(B
            SndBuf[6] = (unsigned char)(data / 32 + 0x40);  // $B>e0L(B5$B%S%C%HJ,(B
            SndBuf[7] = (unsigned char)(data % 32 + 0x40);  // $B2<0L(B5$B%S%C%HJ,(B
            data = GetADC(1);                               // CH1$B$N(BA/D$BJQ49(B
            SndBuf[8] = (unsigned char)(data / 32 + 0x40);  // $B>e0L(B5$B%S%C%HJ,(B
            SndBuf[9] = (unsigned char)(data % 32 + 0x40);  // $B2<0L(B5$B%S%C%HJ,(B
            SndBuf[10] = 'E';                               // $B=*N;%^!<%/(B
            SendStr(SndBuf);                                // $BAw?.<B9T(B
            break;
        /* $B=PNO@)8f$N>l9g(B */
        case 'C':
            switch(Buffer[2]){                              // $B6hJL5-9f$GJ,4t(B
                case '1':                                   // $B=PNO#1<B9T(B
                    LATAbits.LATA2 = (Buffer[3] == '1') ? 1 : 0;
                    break;
                case '2':                                   // $B=PNO(B2$B<B9T(B
                    LATAbits.LATA3 = (Buffer[3] == '1') ? 1 : 0;
                    break;
                default: break;
            }
            break;
        /* $B=*N;%3%^%s%I$N>l9g(B */
        case 'N':
            SendCmd(msg1);                      // $$$$B$G%3%^%s%I%b!<%I$X(B
            SendCmd(msg14);                     // Close$BAw?.(B
            SendCmd(msg13);                     // Reboot$BAw?.(B
            break;
        default: break;
    }
}
/***************************************
*  USART$B<u?.3d$j9~$_=hM}4X?t(B
****************************************/
void interrupt isr(void){
    unsigned char data;
    int i;

    if(PIR1bits.RCIF){                              // $B<u?.3d$j9~$_$+!)(B
        PIR1bits.RCIF = 0;                          // $B<u?.3d$j9~$_%U%i%0%/%j%"(B
        if((RCSTAbits.OERR) || (RCSTAbits.FERR)){   // $B%(%i!<H/@8$7$?>l9g(B
            data = RCREG;                           // $B%@%_!<FI$_=P$7(B
            RCSTA = 0;                              // USART$BL58z2=(B
            RCSTA = 0x90;                           // USART$B:FM-8z2=(B
        }
        else {                                      // $B@5>o<u?.$N>l9g(B
            if(Index < 32){                         // $B%P%C%U%!%*!<%P!<%U%m!<$G$J$$>l9g(B
                data = RCREG;                       // $B%G!<%?<h$j=P$7(B
                if(data == 'S')                     // $B3+;O%^!<%/$N>l9g(B
                    Index = 0;                      // $B%P%C%U%!%$%s%G%C%/%9%j%;%C%H(B
                RcvBuf[Index] = data;               // $B%G!<%?3JG<(B
                /* $B=*N;%^!<%/$N=hM}(B */
                if(RcvBuf[Index] == 'E'){           // $B=*N;%^!<%/(BE$B8!=P(B
                    i = 0;                          // $B%]%$%s%?%j%;%C%H(B
                    while(i <= Index){              // $B<u?.%P%$%H?t7+$jJV$7(B
                        Buffer[i] = RcvBuf[i];      // $B%3%T!<(B
                        i++;                        // $B%P%C%U%!%]%$%s%?99?7(B
                    }
                    RcvFlag = 1;                    // $B<u?.40N;%U%i%0%;%C%H(B
                }
                Index++;                            // $B%P%C%U%!%]%$%s%?99?7(B
            }
            else{                                   // $B%P%C%U%!%*!<%P!<$N>l9g(B
                data = RCREG;                       // $BFI$_Ht$P$7$FL5;k(B
                Index = 0;                          // $B%$%s%G%C%/%9%j%;%C%H(B
            }
        }
    }
}
/********************************
 * USART $BAw?.<B9T%5%V4X?t(B
 ********************************/
void Send(unsigned char txchar){
    while(!TXSTAbits.TRMT);             // $BAw?.%l%G%#!<BT$A(B
    TXREG = txchar;                     // $BAw?.<B9T(B
}
/********************************
 * WiFi$BJ8;zNsAw?.4X?t(B
 *******************************/
void SendStr(unsigned char * str){
    int i;
    
    for(i= 0; i<32; i++)                // 32$B%P%$%HAw?.(B
        Send(*str++);                   // $BAw?.<B9T(B
}
/********************************
 * WiFi$B%3%^%s%IAw?.4X?t(B
 * $BCY1dA^F~8eLa$k(B
 ********************************/
void SendCmd(const unsigned char *cmd){
    while(*cmd != 0)                    // $B=*C<$^$G7+$jJV$7Aw?.(B
        Send(*cmd++);                   // $BAw?.<B9T(B
    delay_ms(1000);                     // $BJV?.%9%-%C%WMQCY1d(B
}
/**************************************************
*  $B%"%J%m%0%G!<%?F~NO4X?t(B
*  AD$B%3%s%P!<%?$NF~NO@)8f(B
***************************************************/
int GetADC(int ch){
    int value;

    /* $B29EY7WB,(B */
    ADCON0 = (ch << 2) + 0x01;		// $B%A%c%M%kA*Br!"(BADC$BM-8z2=(B
    delay_us(20);                       // $B%"%/%$%8%7%g%sBT$A(B
    ADCON0bits.GO = 1;                  // AD$BJQ493+;O(B
    while (ADCON0bits.GO);		// AD$BJQ4940N;BT$A(B
    value = ADRESL+(ADRESH*256);	// 10bit$B$NCM$KJQ49(B
    return(value);                      // $BJQ497k2L<hF@(B
}
/***************************************
* int$B@0?t$+$i(BASCII$BJ8;z$KJQ49(B
****************************************/
void itostring(unsigned char digit, unsigned int data, unsigned char *buffer){
	unsigned char i;

	buffer += digit;			// $B:G8e$N?t;z0LCV(B
	for(i=digit; i>0; i--) {		// $BJQ49$O2<0L$+$i>e0L$X(B
		buffer--;			// $B%]%$%s%?!<#1(B
		*buffer = (data % 10) + '0';	// ASCII$B$X(B
		data = data / 10;		// $B<!$N7e$X(B
	}
}
/***********************************
* Float$B$+$iJ8;zNs$XJQ49(B
* $B9g7WM-8z7e$O(B8$B7e0J2<$H$9$k$3$H(B
***********************************/
void ftostring(int seisu, int shousu, float data, unsigned char *buffer){
    long dumy, i;

    if(shousu != 0)				//$B>.?tIt7e$"$j$+(B
        buffer += seisu+shousu+1;		//$BA4BN7e?t!\>.?tE@(B
    else					//$B>.?tIt7e$J$7$N$H$-(B
        buffer += seisu + shousu;		//$BA4BN7e?t$N$_(B
    buffer--;					//$BG[Ns%]%$%s%?(B-1
    for(i=0; i<shousu; i++)			//$B>.?tIt$r@0?t$KJQ49(B
        data = data * 10;			//$B#1#0G\(B
    /// dumy$B$,%*!<%P!<%U%m!<$9$k$HJQ49IT2D(B($B#87e$,8B3&(B)
    dumy = (long) (data + 0.5);			//$B;M<N8^F~$7$F@0?t$KJQ49(B
    for(i=shousu; i>0; i--)	{		//$B>.?t7e?tJ,7+$jJV$7(B
        *buffer =(dumy % 10)+'0';		//$B?tCM$rJ8;z$KJQ493JG<(B
        buffer--;				//$B3JG<>l=j2<0L$+$i>e0L$X(B
        dumy /= 10;				//$B<!$N7e$X(B
    }
    if(shousu != 0) {				//$B>.?t7e(B0$B$J$i>.?tE@$J$7(B
        *buffer = '.';				//$B>.?tE@$r3JG<(B
        buffer--;				//$B%]%$%s%?(B-1
    }
    for(i=seisu; i>0; i--) {			//$B@0?t7eJ,7+$jJV$7(B
        *buffer = (dumy % 10)+'0';		//$B?tCM$rJ8;z$KJQ493JG<(B
        buffer--;				//$B%]%$%s%?(B-1
        dumy /= 10;				//$B<!$N7e$X(B
    }
    i = 0;					// $B%V%i%s%-%s%0=hM}(B
    buffer++;
    while((i<seisu-1)&&(*buffer == '0')){       // $B>e0L7e$,(B0$B$N4V(B
        *buffer = ' ';				// $B%V%i%s%/$KJQ49(B
        buffer++;
        i++;
    }
}
/**********************************
*  $B%k!<%WCY1d4X?t!!(Busec$BC10L(B
**********************************/
void delay_us(unsigned int usec){
    unsigned int Max, k;

    Max = usec * Fosc/30;
    for(k=0; k<Max; k++)
    {   }
}
/**********************************
*  $B%k!<%WCY1d4X?t!!(Bmsec$BC10L(B
**********************************/
void delay_ms(unsigned int msec){
    int j;

    for(j=0; j<msec; j++)
     delay_us(1000);
}
